function speakPhoneMode()
require "import"
import "android.media.AudioManager"
import "android.content.Context"

context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)

function getPhoneMode()
  local mode = audioManager.getRingerMode()
  if mode == AudioManager.RINGER_MODE_SILENT then
    return "Silent"
  elseif mode == AudioManager.RINGER_MODE_VIBRATE then
    return "Vibrate"
  elseif mode == AudioManager.RINGER_MODE_NORMAL then
    return "Normal"
  else
    return "Unknown"
  end
end

local phoneMode = getPhoneMode()
service.postSpeak(500, "手机模式： " .. phoneMode)
end

require "import"
import "android.widget.SeekBar"
import "android.widget.LinearLayout"
import "android.widget.Button"
import "com.androlua.LuaDialog"
import "android.widget.TextView"
import "android.media.AudioManager"
import "android.content.Context"

context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)

function setVolume(streamType, progress)
audioManager.setStreamVolume(streamType, progress, 0)
end

-- تعديل الدالة setSoundMode لضبط حالة audio mode أو الاهتزاز
function setSoundMode(mode)
currentMode = audioManager.getRingerMode()
if mode == "vibrate" and currentMode ~= AudioManager.RINGER_MODE_VIBRATE then
audioManager.setRingerMode(AudioManager.RINGER_MODE_VIBRATE)
elseif mode == "ring" and currentMode ~= AudioManager.RINGER_MODE_NORMAL then
audioManager.setRingerMode(AudioManager.RINGER_MODE_NORMAL)
end
end

layout = {
LinearLayout,
layout_width = "match_parent",
layout_height = "match_parent",
orientation = 1,

{
LinearLayout,
orientation = 0,
layout_width = "match_parent",

{
TextView,
id = "textview",
text = "系统音量调节工具",
layout_width = "match_parent",
layout_height = "wrap_content",
background = "#ff000000",
textColor = "#f0f8ff",
textSize = "25sp",
gravity = "center",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
{
SeekBar,
id = "soundSeekBar",
onClick=function(v) service.click({{"%speakPhoneMode"}}) dlg.dismiss() end,
layout_width = "match_parent",
layout_height = "80dp",
contentDescription = "铃声： ",
background = "#ff000000",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
{
SeekBar,
id = "callSeekBar",
onClick=function(v) service.click({{"%speakPhoneMode"}}) dlg.dismiss() end,
layout_width = "match_parent",
layout_height = "80dp",
contentDescription = "电话： ",
background = "#ff000000",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
{
SeekBar,
id = "mediaSeekBar",
onClick=function(v) service.click({{"%speakPhoneMode"}}) dlg.dismiss() end, layout_width = "match_parent",
layout_height = "80dp",
contentDescription = "媒体： ",
background = "#ff000000",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
{
SeekBar,
id = "alarmSeekBar",
onClick=function(v) service.click({{"%speakPhoneMode"}}) dlg.dismiss() end,
layout_width = "match_parent",
layout_height = "80dp",
contentDescription = "闹钟： ",
background = "#ff000000",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
{
SeekBar,
id = "notificationSeekBar",
onClick=function(v) service.click({{"%speakPhoneMode"}}) dlg.dismiss() end,
layout_width = "match_parent",
layout_height = "80dp",
contentDescription = "通知： ",
background = "#ff000000",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
{
SeekBar,
id = "accessibilitySeekBar",
onClick=function(v) service.click({{"%speakPhoneMode"}}) dlg.dismiss() end,
layout_width = "match_parent",
layout_height = "80dp",
contentDescription = "无障碍： ",
background = "#ff000000",
},
},

{
LinearLayout,
orientation = 1,
layout_width = "match_parent",
gravity = "center_horizontal",
{
Button,
id = "soundModeButton",
text = "静音关闭",
layout_width = "match_parent",
layout_height = "wrap_content",
onClick = function(v)
local buttonText = soundModeButton.getText()
if buttonText == "静音关闭" then
setSoundMode("vibrate")
soundModeButton.setText("静音开启")
elseif buttonText == "静音开启" then
setSoundMode("ring")
service.playSoundTick()
soundModeButton.setText("静音关闭")
end
end,
onLongClickListener = {
onLongClick = function(v)
dlg.dismiss()
service.click({{"%speakPhoneMode"}})
return true
end},

textSize = "30sp",
background = "#0000ff",
},
},
}

function initializeSeekBar(seekBar, streamType)
maxVolume = audioManager.getStreamMaxVolume(streamType)
currentVolume = audioManager.getStreamVolume(streamType)

seekBar.setMax(maxVolume)
seekBar.setProgress(currentVolume)

seekBar.setOnSeekBarChangeListener(luajava.createProxy("android.widget.SeekBar$OnSeekBarChangeListener", {
onProgressChanged = function(seekBar, progress, fromUser)
if fromUser then
setVolume(streamType, progress)
end
end,
onStartTrackingTouch = function(seekBar) end,
onStopTrackingTouch = function(seekBar) end,
}))
end

dlg = LuaDialog()
dlg.setView(loadlayout(layout))
dlg.show()

initializeSeekBar(soundSeekBar, AudioManager.STREAM_RING)
initializeSeekBar(callSeekBar, AudioManager.STREAM_VOICE_CALL) -- تهيئة شريط المكالمات
initializeSeekBar(mediaSeekBar, AudioManager.STREAM_MUSIC)
initializeSeekBar(alarmSeekBar, AudioManager.STREAM_ALARM)
initializeSeekBar(notificationSeekBar, AudioManager.STREAM_NOTIFICATION)
initializeSeekBar(accessibilitySeekBar, AudioManager.STREAM_ACCESSIBILITY)